Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Communication/3.2/WcfService.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Communication/3.2/WcfService.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Communication/3.2/WcfService.cs	(revision 3931)
@@ -326,6 +326,6 @@
     #region Heartbeat
 
-    public event System.EventHandler<ProcessHeartBeatCompletedEventArgs> SendHeartBeatCompleted;
-    public void SendHeartBeatAsync(HeartBeatData hbd) {
+    public event System.EventHandler<ProcessHeartBeatCompletedEventArgs> ProcessHeartBeatCompleted;
+    public void ProcessHeartBeatAsync(HeartBeatData hbd) {
       if (ConnState == NetworkEnum.WcfConnState.Loggedin)
         Logger.Debug("STARTING: sending heartbeat");
@@ -334,6 +334,6 @@
 
     private void proxy_ProcessHeartBeatCompleted(object sender, ProcessHeartBeatCompletedEventArgs e) {
-      if (e.Error == null && e.Result.Success == true) {
-        SendHeartBeatCompleted(sender, e);
+      if (e.Error == null && e.Result.Success) {
+        ProcessHeartBeatCompleted(sender, e);
         Logger.Debug("ENDED: sending heartbeats");
       } else {
@@ -376,5 +376,5 @@
     }
 
-    public ResponseResultReceived SendStoredJobResultsSync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception, bool finished) {      
+    public ResponseResultReceived StoreFinishedJobResultsSync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception, bool finished) {      
       return proxy.StoreFinishedJobResultStreamed(
         GetStreamedJobResult(clientId, jobId, result, percentage, exception));
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj	(revision 3931)
@@ -202,6 +202,4 @@
     <None Include="Properties\DataSources\Calendar.Appointment.datasource" />
     <None Include="Resources\shutdown-icon.png" />
-    <None Include="Service References\ClientService\Calendar.xsd" />
-    <None Include="Service References\ClientService\System.Drawing.xsd" />
   </ItemGroup>
   <ItemGroup>
@@ -213,4 +211,6 @@
   <ItemGroup>
     <None Include="Resources\exit-48.png" />
+    <None Include="Service References\ClientService\Calendar1.xsd" />
+    <None Include="Service References\ClientService\System.Drawing1.xsd" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs	(revision 3931)
@@ -187,5 +187,5 @@
     }
 
-    private void UpdateGraph(JobStatus[] jobs)
+    private void UpdateGraph(StatusCommons sc)
     {
       ZedGraphControl zgc = new ZedGraphControl();
@@ -208,5 +208,6 @@
       double done = 0;
 
-      if (jobs.Length == 0)
+      
+      /*if (jobs.Length == 0)
       {
         myPane.AddPieSlice(100, Color.Green, 0.1, "");
@@ -217,11 +218,11 @@
         {
           allProgress += jobs[i].Progress;
-        }
-
-        done = allProgress / jobs.Length;
-
-        myPane.AddPieSlice(done, Color.Green, 0, "");
-        myPane.AddPieSlice(1 - done, Color.Red, 0, "");
-      }
+        } */
+
+        //done = allProgress / jobs.Length;
+
+      myPane.AddPieSlice((sc.FreeCores / (double) sc.TotalCores), Color.Red, 0, "");
+      myPane.AddPieSlice(((sc.TotalCores - sc.FreeCores) / (double)sc.TotalCores), Color.Green, 0, "");
+     // }
       //Hides the slice labels
       PieItem.Default.LabelType = PieLabelType.None;
@@ -586,5 +587,5 @@
         }
 
-        UpdateGraph(sc.Jobs);
+        UpdateGraph(sc);
 
         if (sc.Status == NetworkEnumWcfConnState.Connected || sc.Status == NetworkEnumWcfConnState.Loggedin)
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/HeuristicLab.Hive.Client.Core.ClientConsoleService.xsd
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/HeuristicLab.Hive.Client.Core.ClientConsoleService.xsd	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/HeuristicLab.Hive.Client.Core.ClientConsoleService.xsd	(revision 3931)
@@ -7,4 +7,5 @@
       <xs:element minOccurs="0" name="ClientGuid" type="ser:guid" />
       <xs:element minOccurs="0" name="ConnectedSince" type="xs:dateTime" />
+      <xs:element minOccurs="0" name="FreeCores" type="xs:int" />
       <xs:element minOccurs="0" name="Jobs" nillable="true" type="tns:ArrayOfJobStatus" />
       <xs:element minOccurs="0" name="JobsAborted" type="xs:int" />
@@ -12,4 +13,5 @@
       <xs:element minOccurs="0" name="JobsFetched" type="xs:int" />
       <xs:element xmlns:q1="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Client.Common" minOccurs="0" name="Status" type="q1:NetworkEnum.WcfConnState" />
+      <xs:element minOccurs="0" name="TotalCores" type="xs:int" />
     </xs:sequence>
   </xs:complexType>
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.svcmap
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.svcmap	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.svcmap	(revision 3931)
@@ -26,6 +26,6 @@
     <MetadataFile FileName="HeuristicLab.Hive.Client.Core.ClientConsoleService.xsd" MetadataType="Schema" ID="36748734-59b6-4ba4-950d-66ca1a4fc8bb" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
     <MetadataFile FileName="HeuristicLab.Hive.Client.Common.xsd" MetadataType="Schema" ID="0c1369fa-d4cc-4149-b202-00da9dd35972" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
-    <MetadataFile FileName="Calendar.xsd" MetadataType="Schema" ID="09fa9f67-e082-4dcb-9c41-a7a3f0fb7aef" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
-    <MetadataFile FileName="System.Drawing.xsd" MetadataType="Schema" ID="70cfc9bf-b4a8-419b-8c1f-379c0d78f9d2" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
+    <MetadataFile FileName="Calendar1.xsd" MetadataType="Schema" ID="5ec19e4e-fed1-451d-971e-01b8df8dcb0a" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
+    <MetadataFile FileName="System.Drawing1.xsd" MetadataType="Schema" ID="2aa97a8b-a12e-47ca-8bb7-93a3404f40e5" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
   </Metadata>
   <Extensions>
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration91.svcinfo
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration91.svcinfo	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration91.svcinfo	(revision 3931)
@@ -1,4 +1,4 @@
 <?xml version="1.0" encoding="utf-8"?>
-<SavedWcfConfigurationInformation xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" Version="9.1" CheckSum="LJHqHAg9UO+arib7mQMPUcNSFqQ=">
+<SavedWcfConfigurationInformation xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" Version="9.1" CheckSum="BEhVTwOR+7957ZuwDJOXr3mn9MQ=">
   <bindingConfigurations>
     <bindingConfiguration bindingType="netTcpBinding" name="NetTcpBinding_IClientConsoleCommunicator">
@@ -93,4 +93,16 @@
         <property path="/security/transport/protectionLevel" isComplexType="false" isExplicitlyDefined="true" clrType="System.Net.Security.ProtectionLevel, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
           <serializedValue>EncryptAndSign</serializedValue>
+        </property>
+        <property path="/security/transport/extendedProtectionPolicy" isComplexType="true" isExplicitlyDefined="false" clrType="System.Security.Authentication.ExtendedProtection.Configuration.ExtendedProtectionPolicyElement, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <serializedValue>System.Security.Authentication.ExtendedProtection.Configuration.ExtendedProtectionPolicyElement</serializedValue>
+        </property>
+        <property path="/security/transport/extendedProtectionPolicy/policyEnforcement" isComplexType="false" isExplicitlyDefined="false" clrType="System.Security.Authentication.ExtendedProtection.PolicyEnforcement, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <serializedValue>Never</serializedValue>
+        </property>
+        <property path="/security/transport/extendedProtectionPolicy/protectionScenario" isComplexType="false" isExplicitlyDefined="false" clrType="System.Security.Authentication.ExtendedProtection.ProtectionScenario, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <serializedValue>TransportSelected</serializedValue>
+        </property>
+        <property path="/security/transport/extendedProtectionPolicy/customServiceNames" isComplexType="true" isExplicitlyDefined="false" clrType="System.Security.Authentication.ExtendedProtection.Configuration.ServiceNameElementCollection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <serializedValue>(Collection)</serializedValue>
         </property>
         <property path="/security/message" isComplexType="true" isExplicitlyDefined="false" clrType="System.ServiceModel.Configuration.MessageSecurityOverTcpElement, System.ServiceModel, Version=3.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
@@ -137,5 +149,5 @@
         </property>
         <property path="/identity/userPrincipalName/value" isComplexType="false" isExplicitlyDefined="true" clrType="System.String, mscorlib, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-          <serializedValue>mse08004@fhs-hagenberg.ac.at</serializedValue>
+          <serializedValue>semteX-PC\semteX</serializedValue>
         </property>
         <property path="/identity/servicePrincipalName" isComplexType="true" isExplicitlyDefined="false" clrType="System.ServiceModel.Configuration.ServicePrincipalNameElement, System.ServiceModel, Version=3.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/service.wsdl
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/service.wsdl	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/service.wsdl	(revision 3931)
@@ -1,4 +1,4 @@
 ﻿<?xml version="1.0" encoding="utf-8"?>
-<wsdl:definitions xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:wsap="http://schemas.xmlsoap.org/ws/2004/08/addressing/policy" xmlns:wsp="http://schemas.xmlsoap.org/ws/2004/09/policy" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msc="http://schemas.microsoft.com/ws/2005/12/wsdl/contract" xmlns:tns="http://tempuri.org/" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:wsa10="http://www.w3.org/2005/08/addressing" xmlns:wsam="http://www.w3.org/2007/05/addressing/metadata" name="ClientConsoleCommunicator" targetNamespace="http://tempuri.org/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
+<wsdl:definitions xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:wsap="http://schemas.xmlsoap.org/ws/2004/08/addressing/policy" xmlns:wsp="http://schemas.xmlsoap.org/ws/2004/09/policy" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:msc="http://schemas.microsoft.com/ws/2005/12/wsdl/contract" xmlns:tns="http://tempuri.org/" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:wsa10="http://www.w3.org/2005/08/addressing" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:wsam="http://www.w3.org/2007/05/addressing/metadata" name="ClientConsoleCommunicator" targetNamespace="http://tempuri.org/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
   <wsp:Policy wsu:Id="NetTcpBinding_IClientConsoleCommunicator_policy">
     <wsp:ExactlyOne>
@@ -190,5 +190,5 @@
         <wsa10:Address>net.tcp://127.0.0.1:8000/ClientConsole/ClientConsoleCommunicator</wsa10:Address>
         <Identity xmlns="http://schemas.xmlsoap.org/ws/2006/02/addressingidentity">
-          <Upn>mse08004@fhs-hagenberg.ac.at</Upn>
+          <Upn>semteX-PC\semteX</Upn>
         </Identity>
       </wsa10:EndpointReference>
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/ClientConsoleService/TransferObjects/StatusCommons.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/ClientConsoleService/TransferObjects/StatusCommons.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/ClientConsoleService/TransferObjects/StatusCommons.cs	(revision 3931)
@@ -40,4 +40,8 @@
     public DateTime ConnectedSince { get; set; }
     [DataMember]
+    public int TotalCores { get; set; }
+    [DataMember]
+    public int FreeCores { get; set; }
+    [DataMember]
     public int JobsFetched { get; set; }
     [DataMember]
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/ConfigurationManager/ConfigManager.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/ConfigurationManager/ConfigManager.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/ConfigurationManager/ConfigManager.cs	(revision 3931)
@@ -108,4 +108,7 @@
       st.ConnectedSince = WcfService.Instance.ConnectedSince;
 
+      st.TotalCores = hardwareInfo.NrOfCores;
+      st.FreeCores = hardwareInfo.NrOfCores - GetUsedCores();
+
       st.JobsAborted = ClientStatusInfo.JobsAborted;
       st.JobsDone = ClientStatusInfo.JobsProcessed;
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 3931)
@@ -259,4 +259,8 @@
           lock (engines) {
             appDomains[jId].UnhandledException -= new UnhandledExceptionEventHandler(appDomain_UnhandledException);
+            
+            //Disposing it
+            engines[jId].Dispose();
+            
             AppDomain.Unload(appDomains[jId]);
             Logger.Debug("Unloaded appdomain");
@@ -478,4 +482,5 @@
       lock (engines) {
         try {
+          engines[id].Dispose();  
           appDomains[id].UnhandledException -= new UnhandledExceptionEventHandler(appDomain_UnhandledException);
           AppDomain.Unload(appDomains[id]);
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Heartbeat.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Heartbeat.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Heartbeat.cs	(revision 3931)
@@ -65,5 +65,5 @@
       heartbeatTimer.Elapsed += new ElapsedEventHandler(heartbeatTimer_Elapsed);
       wcfService = WcfService.Instance;
-      wcfService.SendHeartBeatCompleted += new EventHandler<ProcessHeartBeatCompletedEventArgs>(wcfService_ProcessHeartBeatCompleted);
+      wcfService.ProcessHeartBeatCompleted += new EventHandler<ProcessHeartBeatCompletedEventArgs>(wcfService_ProcessHeartBeatCompleted);
       heartbeatTimer.Start();
     }
@@ -105,5 +105,5 @@
       } else if (wcfService.ConnState == NetworkEnum.WcfConnState.Loggedin) {
         Logger.Debug("Sending Heartbeat: " + heartBeatData);        
-        wcfService.SendHeartBeatAsync(heartBeatData);
+        wcfService.ProcessHeartBeatAsync(heartBeatData);
       }
     }
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs	(revision 3931)
@@ -1,3 +1,3 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -51,5 +51,5 @@
             byte[] job = File.ReadAllBytes(path + filename + ".dat");
             if (WcfService.Instance.IsJobStillNeeded(storedJobsList[index - 1].JobID).StatusMessage == ApplicationConstants.RESPONSE_COMMUNICATOR_SEND_JOBRESULT) {
-              ResponseResultReceived res = WcfService.Instance.SendStoredJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, storedJobsList[index - 1].JobID, job, 1.00, null, true);
+              ResponseResultReceived res = WcfService.Instance.StoreFinishedJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, storedJobsList[index - 1].JobID, job, 1.00, null, true);
               if (!res.Success)
                 Logger.Error("sending of job failed: " + res.StatusMessage);
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.ExecutionEngine/3.2/Executor.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.ExecutionEngine/3.2/Executor.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.ExecutionEngine/3.2/Executor.cs	(revision 3931)
@@ -33,5 +33,5 @@
 
 namespace HeuristicLab.Hive.Client.ExecutionEngine {
-  public class Executor: MarshalByRefObject {
+  public class Executor: MarshalByRefObject, IDisposable {
     public Guid JobId { get; set; }
     public IJob Job { get; set; }
@@ -109,7 +109,8 @@
         throw new InvalidStateException("Job is still running");
       } else {
-        return SerializeJobObject();
+        byte[] jobArr = SerializeJobObject();        
+        return jobArr;
       }
-    }
+    }    
 
 
@@ -131,5 +132,16 @@
       JobIsFinished = false;
       Job = new TestJob();
-    }    
+    }
+
+    #region IDisposable Members
+
+    public void Dispose() {
+      Job.JobFailed -= new EventHandler(Job_JobFailed);
+      Job.JobFailed -= new EventHandler(Job_JobStopped);
+      Queue = null;
+      Job = null;
+    }
+
+    #endregion
   }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/ApplicationConstants.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/ApplicationConstants.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/ApplicationConstants.cs	(revision 3931)
@@ -29,8 +29,8 @@
   public class ApplicationConstants {
 
-    public static System.Data.IsolationLevel ISOLATION_LEVEL = IsolationLevel.ReadCommitted;
+    public static System.Data.IsolationLevel ISOLATION_LEVEL = IsolationLevel.ReadUncommitted;
 
     public static System.Transactions.IsolationLevel ISOLATION_LEVEL_SCOPE =
-      System.Transactions.IsolationLevel.ReadCommitted;
+      System.Transactions.IsolationLevel.ReadUncommitted;
     public static int HEARTBEAT_MAX_DIF = 120; // value in seconds
     public static int JOB_TIME_TO_LIVE = 5;
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/ClientDto.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/ClientDto.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/ClientDto.cs	(revision 3931)
@@ -39,5 +39,5 @@
     public int NrOfFreeCores { get; set; }
     [DataMember]
-    public int CpuSpeedPerCore { get; set; }
+    public int? CpuSpeedPerCore { get; set; }
     [DataMember]
     public int Memory { get; set; }
@@ -45,5 +45,5 @@
     public int FreeMemory { get; set; }
     [DataMember]
-    public DateTime Login { get; set; }
+    public DateTime? Login { get; set; }
     [DataMember]
     public State State { get; set; }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ClientAdapter.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ClientAdapter.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/ClientAdapter.cs	(revision 3931)
@@ -156,7 +156,7 @@
       if (client != null && row != null) {
         row.ResourceId = client.Id;
-        row.CPUSpeed = client.CpuSpeedPerCore;
+       // row.CPUSpeed = client.CpuSpeedPerCore;
         row.Memory = client.Memory;
-        row.Login = client.Login;
+       // row.Login = client.Login;
         if (client.State != State.nullState)
           row.Status = client.State.ToString();
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj	(revision 3931)
@@ -217,4 +217,8 @@
       <Name>HeuristicLab.PluginInfrastructure</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Tracing\3.2\HeuristicLab.Tracing-3.2.csproj">
+      <Project>{EE2034D9-6E27-48A1-B855-42D45F69A4FC}</Project>
+      <Name>HeuristicLab.Tracing-3.2</Name>
+    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs	(revision 3931)
@@ -33,4 +33,5 @@
 using System.Threading;
 using System.ServiceModel;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Server.ServerConsole {
@@ -263,7 +264,13 @@
         IJobManager jobManager =
           ServiceLocator.GetJobManager();
-        jobs = jobManager.GetAllJobs();
-
-        lvJobControl.Items.Clear();
+        if (jobManager == null) {
+          Logger.Error("Jobmanager is null");
+          jobs = new ResponseList<JobDto>();
+        } else {
+          jobs = jobManager.GetAllJobs();
+        }
+
+
+        if (lvJobControl != null) lvJobControl.Items.Clear();
 
         ListViewGroup lvJobCalculating = new ListViewGroup("calculating", HorizontalAlignment.Left);
@@ -311,4 +318,5 @@
       }
       catch (Exception ex) {
+        Logger.Error(ex);
         closeFormEvent(true, true);
         this.Close();
@@ -790,5 +798,5 @@
     }
 
-    private int CapacityRam(int noCores, int freeCores) {
+    private int CapacityRam(int noCores, int freeCores) {    
       if (noCores > 0) {
         int capacity = ((noCores - freeCores) / noCores) * 100;
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 3931)
@@ -120,5 +120,5 @@
                 Logger.Info("Client timed out and is on RESET");
                 foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfClient(client)) {
-                  jobManager.ResetJobsDependingOnResults(job);
+                  DaoLocator.JobDao.SetJobOffline(job);
                   lock (newAssignedJobs) {
                     if (newAssignedJobs.ContainsKey(job.Id))
@@ -149,5 +149,5 @@
               lastHeartbeats.Remove(client.Id);
             foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfClient(client)) {
-              jobManager.ResetJobsDependingOnResults(job);
+              DaoLocator.JobDao.SetJobOffline(job);
             }
             heartbeatLock.ExitWriteLock();
@@ -428,5 +428,5 @@
       JobDto job2Calculate = scheduler.GetNextJobForClient(clientId);
       if (job2Calculate != null) {
-        response.Job = job2Calculate;
+        response.Job = job2Calculate;        
         response.Job.PluginsNeeded = DaoLocator.PluginInfoDao.GetPluginDependenciesForJob(response.Job);
         response.Success = true;
@@ -481,14 +481,27 @@
 
       if (response.Success) {
-        jobStream = DaoLocator.JobDao.GetSerializedJobStream(result.JobId);
-
+        Logger.Debug("Trying to aquire WCF Job Stream");
+        //jobStream = DaoLocator.JobDao.GetSerializedJobStream(result.JobId);
+        //Logger.Debug("Job Stream Aquired");
         byte[] buffer = new byte[3024];
+        List<byte> serializedJob = new List<byte>();
         int read = 0;
-        while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {
-          jobStream.Write(buffer, 0, read);
-        }
-        jobStream.Close();
+        int i = 0;        
+        while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {          
+          for (int j = 0; j < read; j++) {
+            serializedJob.Add(buffer[j]);
+          }
+          if (i% 100 == 0)
+            Logger.Debug("Writing to stream: " + i);         
+          //jobStream.Write(buffer, 0, read);
+          i++;
+        }
+        Logger.Debug("Done Writing, closing the stream!");               
+        //jobStream.Close();
+
+        DaoLocator.JobDao.SetBinaryJobFile(result.JobId, serializedJob.ToArray());
       }
       Logger.Info("END Job received for Storage:");
+      stream.Dispose();
       return response;
     }
@@ -656,5 +669,5 @@
         foreach (JobDto job in jobsOfClient) {
           if (job.State != State.finished)
-            jobManager.ResetJobsDependingOnResults(job);
+            DaoLocator.JobDao.SetJobOffline(job);
         }
       }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs	(revision 3931)
@@ -114,12 +114,10 @@
       IJobManager jobManager = 
         ServiceLocator.GetJobManager();
-
+      IInternalJobManager internalJobManager = (IInternalJobManager) jobManager;
+      
       //second stream the job binary data
-      
+      MemoryStream memoryStream = new MemoryStream();      
       if(job.Job != null)
-        stream.AddStream(
-          ((IInternalJobManager) (jobManager)).
-            GetJobStreamById(
-            job.Job.Id));
+        stream.AddStream(new MemoryStream(internalJobManager.GetSerializedJobDataById(job.Job.Id)));
       
       OperationContext clientContext = OperationContext.Current;
